#pragma once

#include "preferences.h"
#include "wizard.h"
#include "modeless.h"

// Maella: This class is designed to keep the fingers away from the *.rc files.
//         It should simplify the porting to new versions of the eMule.

// CPPgPhoenix dialog
class CPPgPhoenix : public CPreferencesPage // [TPT] - SLUGFILLER: modelessDialogs
{
	DECLARE_DYNAMIC(CPPgPhoenix)

public:
	CPPgPhoenix();
	virtual ~CPPgPhoenix();

	void SetPrefs(CPreferences* in_prefs) {	app_prefs = in_prefs;}

	void Localize(void);
	void LoadSettings();

	// emulEspaa: added by MoNKi [MoNKi: -invisible mode-]
	afx_msg void OnBnClickedInvisiblemode();
	afx_msg void OnCbnSelchangeKeymodcombo();
	// End MoNKi

	// Dialog Data
	enum { IDD = IDD_PPG_MAELLA }; 

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	// emulEspaa: added by MoNKi [MoNKi: -invisible mode-]	
	UINT			m_iActualKeyModifier;
	// End MoNKi

	DECLARE_MESSAGE_MAP()

public:
	virtual BOOL OnApply();
	virtual BOOL OnInitDialog();
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnSettingsChange() { SetModified(TRUE); }
	afx_msg void OnTabSelectionChange(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnQuickStartChange(void); // [TPT] - quick start

protected:
	CPreferences *app_prefs;

private:
	enum eTab {NONE, UPLOAD, MISCELLANEOUS, CATEGORIES, VISUALIZATION, MINIMULE};
	void SetTab(eTab tab);

	void InitTab();
	void InitControl();	

	// Tab	
	CTabCtrl   m_tabCtr;
	eTab       m_currentTab;
	CImageList m_ImageList;
	
	// [TPT] - SLUGFILLER: hideOS
	CEdit	m_iHideOS;
	CStatic m_iHideOSStatic;
	CButton m_iSelectiveShare;	
	// [TPT] - SLUGFILLER: hideOS
	// [TPT] - itsonlyme: displayOptions START	
	CButton m_iShowFileSystemIcon;
	CButton m_iShowLocalRating; // [TPT] -  SLUGFILLER:showComments
	// [TPT] - itsonlyme: displayOptions END

	
	CButton m_iInfiniteQueue;	// [TPT] - SLUGFILLER: infiniteQueue

	CButton m_iHighContrast;   // [TPT] - MoNKi: -Support for High Contrast Mode-
	
	CButton m_iSpreadBars; // [TPT] - SLUGFILLER: Spreadbars
	
	// [TPT] - quick start
	CButton m_iQuickStart; 
	CEdit m_iMaxConnPerFive;
	CStatic m_iMaxConnPerFiveStatic;
	CEdit m_iMaxConn;
	CStatic m_iMaxConnStatic;
	// [TPT] - quick start
	
	// [TPT] - Select process priority 
	bool ExtraPrios;
	CButton  m_PriorityGroupBox;
	CSliderCtrl m_selectPriorityProcess; 	
	CStatic m_RealTimePriority, m_HighPriority, m_AboveNormalPriority,
		m_NormalPriority, m_BelowNormalPriority, m_IdlePriority;
	// [TPT] - Select process priority 
	
	// [TPT] - TBH: minimule
	CButton  m_MiniMuleGroupBox;
	CButton m_iMiniMule;		
	CButton m_iMiniMuleLives;
	CEdit m_iMiniMuleUpdate;
	CStatic m_iMiniMuleUpdateStatic;
	CSliderCtrl m_MiniMuleTransparency;
	CStatic m_MiniMuleTransparencyStatic;
	CStatic m_MiniMuleTransparencyMinimum, m_MiniMuleTransparencyMaximum;
	// [TPT] - TBH: minimule
	// [TPT] - Credit System
	CSliderCtrl m_iCredits;
	CButton m_iCreditsGroupBox;
	CStatic m_iCreditsPawcioStatic, m_iCreditsLovelaceStatic, 
		m_iCreditsOfficialStatic, m_iCreditsNoneStatic;
	// [TPT] - Credit System

	// emulEspaa: added by MoNKi [TPT] - [MoNKi: -invisible mode-]
	CButton m_InvisibleModeGroupBox;
	CButton m_iInvisibleMode;
	CStatic m_iInvisibleModeSelectStatic;
	CStatic m_iInvisibleModeModifierStatic;
	CStatic m_iInvisibleModeKeyStatic;	
	CStatic m_iInvisibleModePlus;
	CComboBox		m_invmode_keymodifiers;
	CComboBox		m_invmode_keys;
	
	
};